comonad-5.0.2: Comonads

Safe Haskell | Safe
Language | Haskell2010

Data.Functor.Composition

Synopsis

- class Composition o where

# Documentation

class Composition o where Source #

We often need to distinguish between various forms of Functor-like composition in Haskell in order to please the type system. This lets us work with these representations uniformly.

Minimal complete definition

decompose, compose

Methods

decompose :: o f g x -> f (g x) Source #

compose :: f (g x) -> o f g x Source #

Instances

Composition (Compose * *) Source # |
Methods decompose :: Compose * * f g x -> f (g x) Source # compose :: f (g x) -> Compose * * f g x Source #